package com.yingxin.server.client.config;

import com.yingxin.server.client.Service.Impl.UserServiceImpl;
import com.yingxin.server.client.Service.UserService;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.security.core.authority.AuthorityUtils;
import org.springframework.security.core.userdetails.User;
import org.springframework.security.core.userdetails.UserDetails;
import org.springframework.security.core.userdetails.UserDetailsService;
import org.springframework.security.core.userdetails.UsernameNotFoundException;
import org.springframework.security.crypto.bcrypt.BCryptPasswordEncoder;
import org.springframework.stereotype.Component;

/**
 * description//TODO
 *          自定义登陆
 *          配置用户
 *          使用内存中的用户，实际项目中，一般使用的是数据库保存用户，具体的实现类可以使用JdbcDaoImpl或者JdbcUserDetailsManager
 * @author gaozhentao
 * @version 1.0
 * @date 2019/8/13/**
 *
 */
@Component("myUserDetailsService")
public class MyUserDetailsService implements UserDetailsService {

    private org.slf4j.Logger logger = LoggerFactory.getLogger(getClass());

    @Bean
    public UserService userService(){
        return new UserServiceImpl();
    }

    @Autowired
    private UserService userService;

    @Autowired
    BCryptPasswordEncoder bCryptPasswordEncoder;

    @Override
    public UserDetails loadUserByUsername(String username) throws UsernameNotFoundException {
        logger.info("登陆用户名：");
        logger.info(username);
        return new User(username, bCryptPasswordEncoder.encode((userService.findByUsername(username).getPassword())), AuthorityUtils.commaSeparatedStringToAuthorityList("myClient"));
    }

}
